from algorithm.pla.perceptron import Perceptron
from algorithm.pla.transfer_functions import normalized_tanh
from server.testserver import get_testdata, send_result


def test_perceptron():
    response = get_testdata("perceptron_processing")
    results = []

    for data in response['data']:
        # Hole die einzelnen Traningsdaten
        test_id = data['id']
        all_weights = data['weights']
        features = data['input']

        # Der Threshold ist der erste Wert in der Liste.
        # Der Rest sind die anderen Gewichte
        threshold = all_weights[0] * -1
        weights = all_weights[1: len(all_weights)]

        # Klassifizere die Trainingsdaten
        perceptron = Perceptron(weights, threshold, normalized_tanh)
        result = perceptron.classify(features)

        # Hänge das Ergebnis in der Liste an
        results.append({'id': test_id, 'value': result})

    # Sende die Ergebnis-Liste zurück an das IUL
    send_result('perceptron_processing', {'session': response['session'], 'results': results})


if __name__ == '__main__':
    test_perceptron()
