from features.moving_feature import moving_feature
from features.standard_deviation import standard_deviation
from korpus import create_bewegung


def binary_classification_feature(window_size=30):

    # Wir holen uns den Höhensensor des Fußes (Bleibt bei Kniebeugen gleich und bewegt sich beim Laufen)
    joggen_values = create_bewegung('joggen').messungen[1].sensoren[1].werte
    kniebeuge_values = create_bewegung('kniebeuge').messungen[1].sensoren[1].werte

    # Berechne die Standardabweichung (Bei Kniebeugen gering, bei Joggen hoch)
    joggen_feature = moving_feature(standard_deviation, window_size, joggen_values)
    kniebeuge_feature = moving_feature(standard_deviation, window_size, kniebeuge_values)

    return joggen_feature, kniebeuge_feature


if __name__ == '__main__':
    binary_classification_feature(30)
