from math import sqrt

from features.arithmetic_mean import arithmetic_mean
from server.testserver import get_testdata, send_result


def standard_deviation(values: list):
    """ Berechnet die Standardabweichung zu einer Zahlenfolge """
    mean = arithmetic_mean(values)

    altered_values = [(x - mean) ** 2 for x in values]
    summe = sum(altered_values) / (len(values) - 1)

    return sqrt(summe)


def test_standard_deviation():
    """ Testet die Standardabweichung gegen das IUL"""

    response = get_testdata("standard_deviation")
    results = []

    for signal in response['signals']:
        # Hole die Parameter des Signals
        test_id = signal['id']
        values = signal['values']

        # Berechne die Standardabweichung des Signals
        result = standard_deviation(values)

        # Hänge das Ergebnis in der Liste an
        results.append({'id': test_id, 'standard_deviation': result})

    # Sende die Ergebnis-Liste zurück an das IUL
    send_result('standard_deviation', {'session': response['session'], 'results': results})


if __name__ == '__main__':
    test_standard_deviation()
