from features.extremwerte import maximum as maxi, minimum as mini, summe as summ

from features.arithmetic_mean import arithmetic_mean
from features.median import median
from features.standard_deviation import standard_deviation


class Sensor:

    def __init__(self, name, werte):
        self.name = name
        self.werte = werte

    def mittelwert(self):
        return arithmetic_mean(self.werte)

    def median(self):
        return median(self.werte)

    def standardabweichung(self):
        return standard_deviation(self.werte)

    def maximum(self):
        return maxi(self.werte)

    def minimum(self):
        return mini(self.werte)

    def summe(self):
        return summ(self.werte)

    def get_characterisation(self):
        return f"""
    {self.name}:
    Mittelwert: {self.mittelwert()}
    Median: {self.median()}
    Standardabweichung: {self.standardabweichung()}
    Maximum: {self.maximum()}
    Minimum: {self.minimum()}
        """
