import matplotlib.pyplot as plotter

from korpus import Sensor


def plot_sensor(sensor: Sensor):
    y_values = sensor.werte
    x_values = range(len(y_values))
    name = sensor.name

    plotter.plot(x_values, y_values, label=name, linewidth=0.2)


def plot_sensors(sensors: list):
    for sensor in sensors:
        plot_sensor(sensor)

    plotter.legend()
    plotter.savefig('line.svg', dpi=2400)


def plot_scatters(scatters: list):
    for scatter in scatters:
        y_values = scatter['values']
        x_values = range(len(y_values))
        name = scatter['name']

        plotter.scatter(x_values, y_values, label=name, s=0.2)

    plotter.legend()
    plotter.savefig('scatter.svg', dpi=2400)
